<?php
/*
* plugin name: Welcart Custom Media Uploader
* Plugin URI: http://web.contempo.jp/weblog/tips/p636
* description: Custom media uploader and file renamer for welcart e-Commerce plugin
* author: Mizuho Ogino 
* author URI: http://web.contempo.jp/
* version: 1.2
* license: http://www.gnu.org/licenses/gpl.html GPL v2 or later
*/

/////////////////////// メタボックスの追加と保存 /////////////////////// 

add_action("do_meta_boxes", "uploader_for_welcart_metabox");
function uploader_for_welcart_metabox(){ // 投稿編集画面にメタボックスを追加する
	$itemcode = ''; $page = '';
	if ( isset($_GET['post']) ) $itemcode = get_post_meta( absint($_GET['post']), '_itemCode', true );
	if ( isset($_GET['page']) ) $page = $_GET['page'];
	if ( $page == 'usces_itemedit' || $page == 'usces_itemnew' || $itemcode ) { // welcartの投稿のときのみ表示する
		add_meta_box( 'my_upload', '商品画像', 'my_upload_postmeta', 'post', 'side','high' ); // 商品画像メタボックスの作成
		remove_meta_box( 'item-main-pict', 'post', 'side' ); // 既存の画像メタボックスの削除
	}
}
add_action("admin_init", "uploader_for_welcart_init");
function uploader_for_welcart_init(){
	add_action( 'save_post', 'save_my_upload_postmeta' ); // 商品画像メタデータの保存
}


/////////////////////// 商品画像メタボックス /////////////////////// 

function my_upload_postmeta(){
	global $post;
	$post_id = $post->ID;
	$my_upload_li = '';
	$ex_images = array();
	$my_uploaded_ids = get_post_meta( $post_id, '_my_upload_images', true );
	if ($my_uploaded_ids): foreach( $my_uploaded_ids as $key => $img_id ):
		$ex_images[] = $img_id;
	endforeach; endif;
	global $usces; // WELCARTの登録画像処理 START
	$itemcode = get_post_meta( $post_id, '_itemCode', true );
	$mainpict = $usces->get_mainpictid( $itemcode );
	$welups = array();
	if ( !in_array( $mainpict, $ex_images ) ) $welups[] = $mainpict;
	$pictids = $usces->get_pictids( $itemcode );
	if ($pictids): foreach ($pictids as $valid):
		if ( !in_array( $valid, $ex_images ) ) $welups[] = $valid;
	endforeach; endif;
	if ( !empty( $welups[0] ) ): foreach ($welups as $welid): // カスタムフィールドに登録されていないWELCARTの登録画像がある場合
		add_post_meta( $post_id, '_my_upload_images', $welid ); // IDの登録
		$ex_images[] = $welid;
		$att_post = array();
		$att_post['ID'] = $welid;
		$att_post['post_parent'] = $post_id;
		wp_update_post( $att_post ); // 投稿への紐付け処理
		echo '<!--ライブラリにアップロードされた画像（ID:' .$welid. ')をこのアイテム（ID:' .$post_id. '）に紐付けしました。-->';
	endforeach; endif;
	// WELCARTの登録画像処理 END
	if($ex_images): foreach( $ex_images as $img_id ):
		$thumb_src = wp_get_attachment_image_src ($img_id,'medium'); // サムネイルのときはthumbnailを指定
		if ( empty ($thumb_src[0]) ){ // 画像が存在しない空IDを強制的に取り除く
			delete_post_meta( $post_id, '_my_upload_images', $img_id );
		} else {
			$my_upload_li.= 
			"\t".'<li class="img" id="img_'.$img_id.'">'."\n".
			"\t\t".'<span class="img_wrap">'."\n".
			"\t\t\t".'<a href="#" class="my_upload_images_remove" title="画像を削除する"></a>'."\n".
			"\t\t\t".'<img src="'.$thumb_src[0].'"/>'."\n".
			"\t\t\t".'<input type="hidden" name="_my_upload_images[]" value="'.$img_id.'" />'."\n".
			"\t\t".'</span>'."\n".
			"\t".'</li>'."\n";
		}
	endforeach; endif;
?>
<style type="text/css">
	#my_upload .inside { padding-top:8px; padding-bottom:13px; }
	#my_upload_images { display:block; list-style-type:none; margin:0; padding:0; }
	#my_upload_images:after { content:''; display:block; height:0; clear:both; visibility:hidden; }
	#my_upload_images li { float:left; margin:6px; padding:0; height:160px; }
	#my_upload_images li span { display:inline-block; max-width:100%; margin:0; padding:5px; position:relative; background:#eee; -webkit-box-sizing:border-box; -moz-box-sizing:border-box; box-sizing:border-box; }
	#my_upload_images li span:hover { background:#9cc; cursor:move; }
	#my_upload_images li span img { margin:0; padding:0; max-height:150px; width:auto; vertical-align:text-bottom; }
	#my_upload_images li span input { display:none; }
	@media screen and (min-width : 851px){
		#side-sortables #my_upload_images li { height:auto; float:none; width:100%; margin:11px auto; text-align:center; }
		#side-sortables #my_upload_images li span img { max-height:130px; max-width:100%; width:auto; height:auto; }
	}
	@media screen and (max-width : 850px){
		#my_upload_images li { float:left; margin:8px; padding:0; height:138px; }
		#my_upload_images li span { padding:4px; }
		#my_upload_images li span img { max-height:130px; max-width:100%; width:auto; height:auto; }
	}
	#my_upload_images li span a.my_upload_images_remove { position:absolute; top:-9px; right:-9px; height:32px; width:32px; text-align:center; vertical-align:middle; background:#ddd; border-radius:50%; }
	#my_upload_images li span a.my_upload_images_remove:before { content:'×'; display:inline-block; text-decoration:none; width:1em; margin-right:.2em; text-align:center; font-size:20px; line-height:20px; padding:6px; color:#fff; font-weight:bold; }
	#my_upload_images li span a.my_upload_images_remove:hover { background:#387; }
	#my_upload_buttons a { padding:6px; margin-bottom:20px; height:32px; width:100%; line-height:20px; font-weight:bold; text-align:center; }
</style>
<div id="my_upload_buttons">
	<a id="my_upload_media" type="button" class="button" title="商品画像を追加・変更します">商品画像の追加・編集</a>
</div>
<ul id="my_upload_images">
<?php echo $my_upload_li; ?>
<input type="hidden" name="my_nonce" value="<?php echo wp_create_nonce(basename(__FILE__)); ?>" />
</ul>
<script type="text/javascript">
jQuery( function( $ ){
	var custom_uploader;
	$( '#my_upload_media' ).click( function( e ) {
		e.preventDefault();
		if (custom_uploader) {
			custom_uploader.open();
			return;
		}
		custom_uploader = wp.media({
			title: '商品画像をアップロード',
			library: {
				uploadedTo: wp.media.view.settings.post.id,
				type: 'image'
			},
			button: {
				text: '商品画像を選択'
			},
			multiple: true, // falseのとき画像選択は一つのみ可能
			frame: 'select', // select（左のnavを取り除く）|| post（デフォルト）
			editing:   false,
		});
		custom_uploader.on( 'close', function( ){
			var selection = custom_uploader.state().get('selection'),
				this_id = 0, 
				ex_ul = $( '#my_upload_images' ),
				ex_ids = [];
			ex_ul.children( 'li' ).each( function( ){
				this_id = Number( $(this).attr( 'id' ).slice(4) );
				ex_ids.push( this_id );
			});
			selection.each( function( file ){
				this_id = file.toJSON().id;
				if ( $.inArray( this_id, ex_ids ) > -1 ){ // 投稿編集画面のリストに重複している場合、削除
					ex_ul.find( 'li#img_' + this_id ).remove();
				}
				ex_ul.append( '<li class="img" id="img_' + this_id + '"></li>' ).find( 'li:last' ).append(
					'<span class="img_wrap">' + 
					'<a href="#" class="my_upload_images_remove" title="画像を削除する"></a>' +
					'<img src="' + file.attributes.url + '" />' + // サムネイルサイズのときはfile.attributes.sizes.medium.urlを指定
					'<input type="hidden" name="_my_upload_images[]" value="'+ this_id +'" />' + 
					'</span>'
				);
			});
		});
		custom_uploader.open();
	});
	$( '.my_upload_images_remove' ).live( 'click', function( e ) {
		e.preventDefault();
		e.stopPropagation();
		img_obj = $(this).parents( 'li.img' ).remove();
	});
	$( '#my_upload_images' ).sortable({
		cursor : 'move',
		tolerance : 'pointer',
		opacity: 0.6
	});
});
</script>
<?php 
}


/////////////////////// 商品画像メタデータの保存と更新 ///////////////////////
 
function save_my_upload_postmeta( $post_id ){ // データ更新時の保存
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post_id; // 自動保存ルーチンの時は何もしない
	if ( !isset($_POST['my_nonce']) || isset($_POST['my_nonce']) && !wp_verify_nonce($_POST['my_nonce'], basename(__FILE__))) return $post_id; // wp-nonceチェック
	if ( !current_user_can( 'edit_post', $post_id ) ) return $post_id; // ユーザー権限のチェック
	if ( !$itemcode = get_post_meta( $post_id, '_itemCode', true ) ) return $post_id; // welcartの投稿かどうかを判断
	$new_images = isset($_POST['_my_upload_images']) ? $_POST['_my_upload_images']: null; //POSTされたデータ
	$ex_images = get_post_meta( $post_id, '_my_upload_images', true ); //DBのデータ
	global $usces; 
	$mainpict = $usces->get_mainpictid( $itemcode );
	if ( $new_images ){
		if ( $ex_images !== $new_images || $new_images[0] !== $mainpict ){ // 画像に更新があった場合 または　SKUが変更された場合
			rename_welcart_thumbnail( $post_id, $new_images, $ex_images, $itemcode ); // welcart画像用にリネーム処理
			update_post_meta( $post_id, '_my_upload_images', $new_images ); // アップデート
		} 
	} elseif ( $ex_images ) {
		rename_welcart_thumbnail( $post_id, false, $ex_images, $itemcode ); // welcart画像用にリネーム処理
		delete_post_meta( $post_id, '_my_upload_images', $ex_images ); 
		// リネーム処理はアップデートより先にすること
		// welcartのsave_postファンクション内では$postは呼び出せない模様
	} else {
		delete_post_meta( $post_id, '_my_upload_images', $ex_images ); 
	}
}

function rename_welcart_thumbnail( $post_id, $new_images, $ex_images, $itemcode ) { //画像のリネーム処理（welcart仕様）
	$this_ids = array();
	$codestr = '-';
	$op = get_option('usces');
	if ( $op['system']['subimage_rule'] ) $codestr = '--'; // システム設定の【商品サブ画像適用ルール】を新しいルールを適用
	if ( $new_images ): foreach ( $new_images as $key => $img_id ):
		if ( $key === 0 ) { // 最初の画像
			wp_update_post( array( "ID"=>$img_id, "post_title"=>$itemcode )); //メイン画像のタイトルを商品コードに変更
			update_post_meta( $post_id, '_thumbnail_id', $img_id ); //メイン画像をアイキャッチとして登録、設定が不要の場合コメントアウト
		} else { //２番目以降の画像
			wp_update_post( array( "ID"=>$img_id, "post_title"=>$itemcode.$codestr.$key )); //画像のタイトルを商品コードリネーム（ハイフンふたつ）に変更
		} // システム設定の【商品サブ画像適用ルール】を新しいルールを適用すること、またはハイフンをひとつに設定すること
		$this_ids[] = $img_id;
	endforeach; endif;
	if ( $ex_images ): foreach ( $ex_images as $key => $img_id ):
		if ( !in_array ($img_id, $this_ids ) ) { //リストから削除された画像ID
			wp_update_post( array( "ID"=>$img_id, "post_title"=>'img_'.$img_id )); //画像のタイトルから商品コードを取り除いてリネーム
		}
	endforeach; endif;
}
?>